//*****************************************************************************************************
//  1. t@C
//		GraphView.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^Ot̃EBhENX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "GraphView.h"
#include "GraphFrm.h"
#include "Define.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// }EXړ[h
#define MOUSE_MOVE_NONE		0
#define MOUSE_MOVE_SELECT	1
#define MOUSE_MOVE_SCROLL	2

// XN[o[̍ől
#define SCROLL_MAX		0x7ffffffe

// c̃XN[o[ID
#define IDC_SCROLL_X	200
#define IDC_SCROLL_Y	201
#define IDC_SCROLL_Z	202

// CGraphView

//*****************************************************************************************************
//  1. ֐
//		CGraphView::CGraphView
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CGraphView::CGraphView()
{
	// oϐ
	m_sizeBitmap = 0;
	m_bSetBitmap = FALSE;
	m_nMouseMoveMode = MOUSE_MOVE_NONE;
	m_bAutoScroll = FALSE;

	// \[XJ[\擾
	m_hCursorHandClose = AfxGetApp()->LoadCursor(IDC_HANDCLOSE);
}


BEGIN_MESSAGE_MAP(CGraphView, CWnd)
	ON_WM_PAINT()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
END_MESSAGE_MAP()


//*****************************************************************************************************
//  1. ֐
//		CGraphView::PreCreateWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhE쐬O
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CREATESTRUCT		&cs			[I] EBhE쐬\
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CGraphView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.style |= WS_HSCROLL | WS_CLIPCHILDREN;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnPaint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		yCg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnPaint() 
{
	CPaintDC dc(this);

	if (m_bSetBitmap) {
		CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();

		// foCXReLXgɃrbg}bvݒ
		CBitmap *pBitmapOrg = m_dcGraph.SelectObject(&m_bmpGraph);

		// Ot̃rbg}bvʂɓ]
		dc.BitBlt(0, 0, m_sizeBitmap.cx, m_sizeBitmap.cy, &m_dcGraph, 0, 0, SRCCOPY);

		// ԃJ[\`
		m_cDrawGraph.DrawTimeCursor(dc, pGraphFrame->m_cGraphData, pGraphFrame->m_nGraphKind);

		// foCXReLXgrbg}bv폜
		m_dcGraph.SelectObject(pBitmapOrg);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnHScroll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nSBCode			[I] XN[vR[h
//		UINT		nPos			[I] XN[{bNẌʒu
//		CScrollBar	*pScrollBar		[I] XN[o[Rg[ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO si;

	// ݂̃XN[擾
	GetScrollInfo(SB_HORZ, &si);
	int nPageSize = si.nPage;
	int nLineSize = nPageSize / 32;
	if (nLineSize == 0)
		nLineSize = 1;

	// XN[ʒuXV
	switch (nSBCode) {
	case SB_LEFT:
		nPos = 0;
		break;
	case SB_LINELEFT:
		nPos = si.nPos - nLineSize;
		break;
	case SB_LINERIGHT:
		nPos = si.nPos + nLineSize;
		break;
	case SB_PAGELEFT:
		nPos = si.nPos - nPageSize;
		break;
	case SB_PAGERIGHT:
		nPos = si.nPos + nPageSize;
		break;
	case SB_RIGHT:
		nPos = si.nMax - si.nPage;
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		nPos = si.nTrackPos;
		break;
	default:
		return;
	}

	if (nPos != si.nPos) {
		CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
		CGraphData &cGraphData = pGraphFrame->m_cGraphData;

		// XN[
		cGraphData.m_stTimeRange.fBegin = cGraphData.m_stTimeRange.fMin + (int)nPos * cGraphData.m_stTimeRange.fSpan / si.nMax;
		pGraphFrame->UpdateGraph();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnVScroll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nSBCode			[I] XN[vR[h
//		UINT		nPos			[I] XN[{bNẌʒu
//		CScrollBar	*pScrollBar		[I] XN[o[Rg[ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO si;

	// ݂̃XN[擾
	pScrollBar->GetScrollInfo(&si);
	int nPageSize = si.nPage;
	int nLineSize = nPageSize / 32;
	if (nLineSize == 0)
		nLineSize = 1;

	// XN[ʒuXV
	switch (nSBCode) {
	case SB_LEFT:
		nPos = 0;
		break;
	case SB_LINELEFT:
		nPos = si.nPos - nLineSize;
		break;
	case SB_LINERIGHT:
		nPos = si.nPos + nLineSize;
		break;
	case SB_PAGELEFT:
		nPos = si.nPos - nPageSize;
		break;
	case SB_PAGERIGHT:
		nPos = si.nPos + nPageSize;
		break;
	case SB_RIGHT:
		nPos = si.nMax - si.nPage;
		break;
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		nPos = si.nTrackPos;
		break;
	default:
		return;
	}

	if (nPos != si.nPos) {
		CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
		CGraphData &cGraphData = pGraphFrame->m_cGraphData;

		// cXN[
		SDispRange *pLevelRange;
		switch (pScrollBar->GetDlgCtrlID()) {
		case IDC_SCROLL_X:
			pLevelRange = &cGraphData.m_stLevelRangeX;
			break;
		case IDC_SCROLL_Y:
			pLevelRange = &cGraphData.m_stLevelRangeY;
			break;
		case IDC_SCROLL_Z:
			pLevelRange = &cGraphData.m_stLevelRangeZ;
			break;
		}
		pLevelRange->fBegin = pLevelRange->fMin + (int)(si.nMax - si.nPage - nPos) * pLevelRange->fSpan / si.nMax;
		pGraphFrame->UpdateGraph();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhETCYύX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nType			[I] TCYύX̃^Cv
//		int		cx				[I] EBhE̕
//		int		cy				[I] EBhE̍
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	// OtXV
	if (cx != 0 && cy != 0) {
		CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
		pGraphFrame->UpdateGraph();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::UpdateGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot\XV
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::UpdateGraph()
{
	CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
	CGraphData &cGraphData = pGraphFrame->m_cGraphData;

	// NCAg̈̃TCY擾
	CRect rectClinet;
	GetClientRect(rectClinet);
	CSize sizeView(rectClinet.Width(), rectClinet.Height());

	// rbg}bv쐬
	CreateBitmap(sizeView);

	// foCXReLXgɃrbg}bvݒ
	CBitmap *pBitmapOrg = m_dcGraph.SelectObject(&m_bmpGraph);

	// Ot`
	m_cDrawGraph.DrawGraph(m_dcGraph, rectClinet, cGraphData, TRUE, pGraphFrame->m_nGraphKind);

	// foCXReLXgrbg}bv
	m_dcGraph.SelectObject(pBitmapOrg);

	// rbg}bvݒtOݒ
	m_bSetBitmap = TRUE;

	// XN[o[ݒ
	SetScrollBar();

	// NCAg̈𖳌
	Invalidate(FALSE);

	// EBhEXV
	UpdateWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::CreateBitmap
//----------------------------------------------------------------------------------------------------
//  2. @\
//		rbg}bv쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CSize	sizeBitmap			[I] rbg}bṽTCY
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::CreateBitmap(CSize sizeBitmap)
{
	// NCAg̈̃TCYɍ킹ărbg}bv쐬
	if (m_sizeBitmap != sizeBitmap) {
		m_sizeBitmap = sizeBitmap;

		CDC *pDC = GetDC();
		m_bmpGraph.DeleteObject();
		m_bmpGraph.CreateCompatibleBitmap(pDC, m_sizeBitmap.cx, m_sizeBitmap.cy);
		ReleaseDC(pDC);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::SetScrollBar
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[o[ݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::SetScrollBar()
{
	CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
	CGraphData &cGraphData = pGraphFrame->m_cGraphData;
	SCROLLINFO si;

	// XN[o[ݒ
	MakeScrollInfo(cGraphData.m_stTimeRange, si, FALSE);
	SetScrollInfo(SB_HORZ, &si);

	// wXN[o[ݒ
	MakeScrollInfo(cGraphData.m_stLevelRangeX, si, TRUE);
	m_cScrollBarX.SetScrollInfo(&si);

	// xXN[o[ݒ
	MakeScrollInfo(cGraphData.m_stLevelRangeY, si, TRUE);
	m_cScrollBarY.SetScrollInfo(&si);

	// yXN[o[ݒ
	MakeScrollInfo(cGraphData.m_stLevelRangeZ, si, TRUE);
	m_cScrollBarZ.SetScrollInfo(&si);

	m_cDrawGraph.DispScrollBar(m_cScrollBarX, m_cScrollBarY, m_cScrollBarZ);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::MakeScrollInfo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XN[ݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		SDispRange	&stDispRange		[I] \͈͏
//		SCROLLINFO	&si					[O] XN[
//		BOOL		bDir				[I] FASLE:XN[@TRUEFXN[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::MakeScrollInfo(const SDispRange &stDispRange, SCROLLINFO &si, BOOL bDir)
{
	memset(&si, 0, sizeof(si));
	si.cbSize = sizeof(si);
	si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE;
	si.nMax = SCROLL_MAX;
	si.nMin = 0;
	si.nPage = stDispRange.fDisp <= stDispRange.fSpan ? (int)(SCROLL_MAX * stDispRange.fDisp / stDispRange.fSpan) : SCROLL_MAX;
	if (!bDir)
		si.nPos = (int)(SCROLL_MAX * (stDispRange.fBegin - stDispRange.fMin) / stDispRange.fSpan);
	else
		si.nPos = si.nMax - si.nPage - (int)(SCROLL_MAX * (stDispRange.fBegin - stDispRange.fMin) / stDispRange.fSpan);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnCreate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhE쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCREATESTRUCT		lpCreateStruct			[I] EBhE쐬\̂ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		0F@-1FG[
//*****************************************************************************************************
int CGraphView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// foCXReLXg쐬
	CDC *pDC = GetDC();
	m_dcGraph.CreateCompatibleDC(pDC);
	ReleaseDC(pDC);

	// c̃XN[o[쐬
	CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
	CRect rect(0, 0, 0, 0);
	m_cScrollBarX.Create(SBS_VERT | WS_CHILD | WS_VISIBLE, rect, this, IDC_SCROLL_X);
	if (pGraphFrame->m_nGraphKind == GRAPH_ACCEL || pGraphFrame->m_nGraphKind == GRAPH_ZERO_OFFSET) {
		m_cScrollBarY.Create(SBS_VERT | WS_CHILD | WS_VISIBLE, rect, this, IDC_SCROLL_Y);
		m_cScrollBarZ.Create(SBS_VERT | WS_CHILD | WS_VISIBLE, rect, this, IDC_SCROLL_Z);
	}

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnLButtonDown
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EX{^_E
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] J[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnLButtonDown(UINT nFlags, CPoint point)
{
	CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
	CGraphData &cGraphData = pGraphFrame->m_cGraphData;

	// ԃJ[\ʒuݒ
	pGraphFrame->SetTimeCursor(cGraphData.m_stTimeRange.fBegin + cGraphData.m_stTimeRange.fDisp * (point.x - m_cDrawGraph.m_rectScale.left) / m_cDrawGraph.m_rectScale.Width());

	if (cGraphData.m_fTimeCursor <= cGraphData.m_stTimeRange.fMin + cGraphData.m_fTimeDispEnd) {
		// I͈͂
		m_fSelectStartTime = cGraphData.m_fSelectBegin = cGraphData.m_fSelectEnd = cGraphData.m_fTimeCursor;
		pGraphFrame->UpdateSelectArea();

		// }EXLv`
		SetCapture();

		// }EXړ[hݒ
		m_nMouseMoveMode = MOUSE_MOVE_SELECT;
	}

	CWnd::OnLButtonDown(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnLButtonUp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EX{^Abv
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] J[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// }EX[X
	if (GetCapture()->GetSafeHwnd() == m_hWnd)
		ReleaseCapture();

	// }EXړ[h
	m_nMouseMoveMode = MOUSE_MOVE_NONE;

	CWnd::OnLButtonUp(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnMouseMove
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] J[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnMouseMove(UINT nFlags, CPoint point)
{
	CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
	CGraphData &cGraphData = pGraphFrame->m_cGraphData;
	double fSelect;
	SDispRange *pLevelRange;

	switch (m_nMouseMoveMode) {
	case MOUSE_MOVE_SELECT:		// I
		switch (pGraphFrame->m_nGraphKind) {
		case GRAPH_ACCEL:
			fSelect = cGraphData.m_stTimeRange.fBegin + cGraphData.m_stTimeRange.fDisp * (point.x - m_cDrawGraph.m_rectScale.left) / m_cDrawGraph.m_rectScale.Width();
			if (fSelect < cGraphData.m_stTimeRange.fBegin)
				fSelect = cGraphData.m_stTimeRange.fBegin;
			else if (fSelect > cGraphData.m_stTimeRange.fBegin + cGraphData.m_stTimeRange.fDisp)
				fSelect = cGraphData.m_stTimeRange.fBegin + cGraphData.m_stTimeRange.fDisp;
			if (fSelect > m_fSelectStartTime) {
				cGraphData.m_fSelectBegin = m_fSelectStartTime;
				cGraphData.m_fSelectEnd = fSelect;
			} else {
				cGraphData.m_fSelectBegin = fSelect;
				cGraphData.m_fSelectEnd = m_fSelectStartTime;
			}
			pGraphFrame->UpdateSelectArea();
			break;
		}
		break;
	case MOUSE_MOVE_SCROLL:		// XN[
		// XN[Ȃ}EẌʒuɍ킹ăEBhEXN[
		CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
		cGraphData.m_stTimeRange.fBegin = cGraphData.m_stTimeRange.fBegin + cGraphData.m_stTimeRange.fDisp * (m_pointScroll.x - point.x) / m_cDrawGraph.m_rectScale.Width();
		switch (m_nScroolGraph) {
		case 1:
			pLevelRange = &cGraphData.m_stLevelRangeX;
			break;
		case 2:
			pLevelRange = &cGraphData.m_stLevelRangeY;
			break;
		case 3:
			pLevelRange = &cGraphData.m_stLevelRangeZ;
			break;
		}
		pLevelRange->fBegin = pLevelRange->fBegin - pLevelRange->fDisp * (m_pointScroll.y - point.y) / m_cDrawGraph.m_rectScale.Height();
		pGraphFrame->UpdateGraph();
		m_pointScroll = point;
		break;
	}

	// ԃJ[\ʒuݒ
	if (!m_bAutoScroll)
		pGraphFrame->SetTimeCursor(cGraphData.m_stTimeRange.fBegin + cGraphData.m_stTimeRange.fDisp * (point.x - m_cDrawGraph.m_rectScale.left) / m_cDrawGraph.m_rectScale.Width());

	CWnd::OnMouseMove(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnRButtonDown
//----------------------------------------------------------------------------------------------------
//  2. @\
//		E}EX{^_E
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] J[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnRButtonDown(UINT nFlags, CPoint point)
{
	m_nScroolGraph = m_cDrawGraph.CheckGraphPoint(point);
	if (m_nScroolGraph != 0) {
		// }EX|C^ʒuۑ
		m_pointScroll = point;

		// }EXLv`
		SetCapture();

		// }EXړ[hݒ
		m_nMouseMoveMode = MOUSE_MOVE_SCROLL;

		// }EXJ[\ݒ
		m_hCursorSave = ::SetCursor(m_hCursorHandClose);
	}

	CWnd::OnRButtonDown(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnRButtonUp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		E}EX{^Abv
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		CPoint		point			[I] J[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::OnRButtonUp(UINT nFlags, CPoint point)
{
	// }EX[X
	if (GetCapture()->GetSafeHwnd() == m_hWnd)
		ReleaseCapture();

	// }EXJ[\߂
	if (m_nMouseMoveMode == MOUSE_MOVE_SCROLL) {
		::SetCursor(m_hCursorHandClose);
		m_nMouseMoveMode = MOUSE_MOVE_NONE;
	}

	CWnd::OnRButtonUp(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::DispSelectArea
//----------------------------------------------------------------------------------------------------
//  2. @\
//		I͈͕\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CGraphView::DispSelectArea()
{
	CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
	CGraphData &cGraphData = pGraphFrame->m_cGraphData;

	// I͈͂`
	CBitmap *pBitmapOrg = m_dcGraph.SelectObject(&m_bmpGraph);
	m_cDrawGraph.DrawSelect(m_dcGraph, cGraphData, pGraphFrame->m_nGraphKind);
	m_dcGraph.SelectObject(pBitmapOrg);

	// NCAg̈𖳌
	Invalidate(FALSE);
}

//*****************************************************************************************************
//  1. ֐
//		CGraphView::OnMouseWheel
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXzC[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] Ă鉼zL[
//		short		zDelta			[I] ]
//		CPoint		pt				[I] }EX̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
BOOL CGraphView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	CGraphFrame *pGraphFrame = (CGraphFrame *)GetParent();
	CGraphData &cGraphData = pGraphFrame->m_cGraphData;
	SDispRange *pLevelRange = NULL;

	ScreenToClient(&pt);
	switch (m_cDrawGraph.CheckGraphPoint(pt)) {
	case 1:
		pLevelRange = &cGraphData.m_stLevelRangeX;
		break;
	case 2:
		pLevelRange = &cGraphData.m_stLevelRangeY;
		break;
	case 3:
		pLevelRange = &cGraphData.m_stLevelRangeZ;
		break;
	}

	if (pLevelRange != NULL) {
		pLevelRange->fBegin = pLevelRange->fBegin + pLevelRange->fDisp * (zDelta / WHEEL_DELTA * 10) / m_cDrawGraph.m_rectScale.Height();
		pGraphFrame->UpdateGraph();
	}

	return TRUE;
}
